@echo off

set cadport=badpw

REM ***************************************************************************
REM Try to determine where vncviewer is.
REM ***************************************************************************
set vncviewercmd=

if exist "%caddir%\vncviewer.exe" set vncviewercmd=%caddir%\vncviewer.exe

if "%vncviewercmd%" == "" (
  echo Cannot find vncviewer.exe in %caddir%
  goto :GOODEOF
)

REM ***************************************************************************
REM Start VNC server on remote system and return the port number.
REM ***************************************************************************
 
del >nul 2>&1 /f /q "%temp%\vncout.txt" "%TEMP%\plinkerr.txt"

echo Connecting to remote system for port...
"%plinkcmd%" >"%TEMP%\vncout.txt" 2>"%TEMP%\plinkerr.txt" %cadhostkey% -2 -4 -batch -pw "%pw%" %uwnetid%@%cadhost% vncstart

REM ***************************************************************************
REM Display any error message
REM ***************************************************************************

set plinkerr=
for /f "usebackq tokens=*" %%i in (`type "%TEMP%\plinkerr.txt"`) do @set plinkerr=%%i

if "%plinkerr%" NEQ "" (
  for /f "usebackq tokens=1" %%i in (`c:\windows\system32\findstr.exe /B "Access Log"  "%temp%\plinkerr.txt"`) do goto :SKIPPLERR

  REM Beware: do NOT use any parens in echo statements below, or script will fail.

  echo %plinkerr%
  echo.
  echo Your IP address may be blocked.
  echo.
  echo Send email to csslab@uw.edu with this info:
  echo To clip -- use mouse on text, click and drag to highlight, then press Enter key:
  echo.
  echo 1. User: %uwnetid%
  echo 2. Cadence: %plinkerr%
  echo 3. From a web browser, visit https://www.whatsmyip.org 
  echo    and copy to the clipboard the IP address shown, and paste it to the email.
  pause
  goto :EOF
)

:SKIPPLERR

REM ***************************************************************************
REM Pull the port number from the vncstart output.
REM ***************************************************************************
for /f "usebackq tokens=2" %%i in (`c:\windows\system32\findstr.exe vncport "%temp%\vncout.txt"`) do @set cadport=%%i

if "%cadport%" == "badpw" (
  echo The MyUW password was not accepted.
  pause
  goto :EOF
)

if "%cadport%" == "none" (
  echo No port was found.
  pause
  goto :EOF
)

echo Port %cadport% acquired. 

REM ***************************************************************************
REM If the tunnel is not started, start it and save its PID for later.
REM ***************************************************************************
tasklist /fi "windowtitle eq Cadence %cadport% tunnel" /fo csv | c:\windows\system32\findstr.exe >NUL 2>&1 /C:"No tasks"

If %ERRORLEVEL% EQU 0 (
  REM *** There cannot be any parentheses in this if-block !!!
  echo Starting the ssh tunnel...

  del >nul 2>&1 /f /q "%temp%\cadman.cadence.sshtunnel.log","%temp%\cadman.cadence.tlout"

  REM *************************************************************************
  REM Start the ssh tunnel.
  REM *************************************************************************

  start "Cadence %cadport% tunnel" /min "%plinkcmd%" %cadhostkey% -N -C -2 -4 -batch -pw "%pw%" %uwnetid%@%cadhost% -L %cadport%:localhost:%cadport% -sshlog "%temp%\cadman.cadence.sshtunnel.log"

  REM *************************************************************************
  REM Get the process id of the tunnel process to kill later.
  REM *************************************************************************

  tasklist >"%temp%\cadman.cadence.tlout" 2>&1 /fi "windowtitle eq Cadence %cadport% tunnel" /fo csv
  
)

REM ***************************************************************************
REM Start VNC client to connect to remote system.
REM ***************************************************************************

echo.
if NOT exist "%temp%\cadman.cadence.pw" (
  REM *** There cannot be any parentheses in this if-block !!!
  REM *************************************************************************
  REM Get the current encrypted VNC password and save it locally.
  REM *************************************************************************

  "%pscpcmd%" %cadhostkey% -2 -4 -q -pw "%pw%" %uwnetid%@%cadhost%:.vnc/passwd "%temp%\cadman.cadence.pw"
)

echo Connecting to Cadence server
"%vncviewercmd%" --passwd="%temp%\cadman.cadence.pw" localhost::%cadport%

:GOODEOF

REM pause
