@echo off

set synport=badpw
set synvncfile=%temp%\vncout.syn.txt
set syntlfile=%temp%\tlout.syn.txt

REM ***************************************************************************
REM Try to determine where vncviewer is.
REM ***************************************************************************
set vncviewercmd=

if exist "%caddir%\vncviewer.exe" set vncviewercmd=%caddir%\vncviewer.exe

if "%vncviewercmd%" == "" (
  echo Cannot find vncviewer.exe in %caddir%
  goto :GOODEOF
)

REM ***************************************************************************
REM Start VNC server on remote system and return the port number.
REM ***************************************************************************
 
del >nul 2>&1 /f /q "%synvncfile%"

echo Connecting to remote system for port...
"%plinkcmd%" >"%synvncfile%" %synhostkey% -batch -pw "%pw%" %uwnetid%@%synhost% vncstart

REM ***************************************************************************
REM Pull the port number from the vncstart output.
REM ***************************************************************************

for /f "usebackq tokens=2" %%i in (`findstr vncport "%synvncfile%"`) do @set synport=%%i

if "%synport%" == "badpw" (
  echo The MyUW password was not accepted.
  goto :GOODEOF
)

if "%synport%" == "none" (
  echo No port was found.
  goto :GOODEOF
)

echo Port %synport% acquired. 
echo Starting the ssh tunnel...

REM ***************************************************************************
REM Start the ssh tunnel.
REM ***************************************************************************

start "Synopsys %synport% tunnel" /min "%plinkcmd%" %synhostkey% -batch -pw "%pw%" %uwnetid%@%synhost% -L %synport%2:localhost:%synport%

REM ***************************************************************************
REM No longer need the password, so remove it from environment.
REM ***************************************************************************
set pw=

REM ***************************************************************************
REM Get the process if of the tunnel process to kill later.
REM ***************************************************************************

tasklist >"%syntlfile%" 2>&1 /fi "windowtitle eq Synopsys %synport% tunnel" /fo csv
for /f "usebackq tokens=2 delims=," %%i in (`type "%syntlfile%"`) do @set tunnelpid=%%~i

REM ***************************************************************************
REM Start VNC client to connect to remote system.
REM ***************************************************************************

echo.
pause

echo Connecting to Synopsys server (default VNC password is cad2015)...
"%vncviewercmd%" localhost:%synport%2

:GOODEOF
REM ***************************************************************************
REM If there is a tunnel process, kill it.
REM ***************************************************************************
if not "%tunnelpid%" == "" taskkill >nul 2>&1 /f /pid %tunnelpid%

set pw=
set tunnelpid=

del /f /q "%syntlfile%","%synvncfile%"
pause
